angular.module('tuinvogels', ['ionic',
    'tuinvogels.controllers',
    'tuinvogels.controllers-dagboek',
    'tuinvogels.controllers-gids',
    'tuinvogels.controllers-telform',
    'tuinvogels.services',
    'services.push',
    'tuinvogels.directives',
    'tuinvogels.filters',
    'tuinvogels.data',
    'jmdobry.angular-cache',
    'ngCordova',
    'ngCordova.plugins.media',
    'mobiscroll-datetime',
    'ngLocale',
    'bitly.generator',
    'social'
])

    .run(function ($ionicPlatform, $rootScope, $angularCacheFactory, $cordovaSplashscreen, $cordovaStatusbar, AuthorizationFactory, PushService) {

        var rootUrl = 'https://www.tuinvogeltelling.nl/';
        //var rootUrl = 'https://tvt15.e-dev.nl/';
        $rootScope.SETTINGS = {
            baseUrl: rootUrl,
            remoteUrl: rootUrl + 'mobile/index.cfm?act=',
            //videoUrl: 'http://www.vogelbescherming.nl/inc/service/video/video.cfm?key=',
            videoUrl: 'https://www.vogelbescherming.nl/video/?video=',
            registerUrl: rootUrl + 'index.cfm?act=registratie.',
            oauthcallback: 'http://localhost:8100/templates/oauthcallback.html',

            header: '<img src="img/logo_tuinvogels.png" height="35" />',
            logo: "img/logo_tuinvogels.png",
            shareImage: "https://images.e-vision.nl/vbn/images/original/31e68d1a-ea0c-469b-b9b8-82de3c31bb7f.jpg&h=400&w=400"
        }

        $rootScope.credentials = AuthorizationFactory.getCredentials();

        $ionicPlatform.ready(function () {

            if (window.cordova && window.cordova.plugins && window.cordova.plugins.splashscreen) {
                $cordovaSplashscreen.hide();
            }

            if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
                //cordova.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            }

            if (window.StatusBar) {
                window.StatusBar.overlaysWebView(false);
                window.StatusBar.backgroundColorByHexString("#08435d");
                window.StatusBar.hide();
                //$cordovaStatusbar.style(1);
                //StatusBar.styleDefault();
            }

            if (typeof analytics !== 'undefined') {
                analytics.startTrackerWithId('UA-11855300-2');
            }
            else {
                console.log("Google Analytics plugin could not be loaded.")
            }

            /*
            window.PushService = PushService;
            window.onNotificationAPN = function (e) {
                window.PushService.onNotificationAPN(e);
            };

            window.onNotification = function (e) {
                window.PushService.onNotification(e);
            };
            */

            var platform = ionic.Platform.platform().toLowerCase();
            $rootScope.isDesktop = (platform === 'macintel');

            /*
            try {
                PushService.register(platform);
            }
            catch (e) {
                //console.log('pusherror', e); 
            };
            */

        });

        $angularCacheFactory('defaultCache');
    })

    .config(function ($stateProvider, $httpProvider, $ionicConfigProvider, $urlRouterProvider, $angularCacheFactoryProvider, bitlyProvider) {

        //initialize default cache settings for all caches
        $angularCacheFactoryProvider.setCacheDefaults({
            maxAge: 900000,
            cacheFlushInterval: 6000000,
            deleteOnExpire: 'aggressive'
        });

        bitlyProvider.cfgBitly({
            login: 'keesschouten',
            api: 'R_6d494e345dc345d2aa8c7fd35b1fd417',
            domain: 'https://api-ssl.bitly.com',    // optional. (http://api.bit.ly by default)
            version: '3'                            // optional. Tested with bitly api versions: 2.0.1 & 3 (3 by default)
        });

        $ionicConfigProvider.views.maxCache(0);
        $ionicConfigProvider.backButton.text('').icon('ion-arrow-left-c');

        $httpProvider.interceptors.push('customAuthHttpInterceptor');
        $httpProvider.defaults.useXDomain = true;
        delete $httpProvider.defaults.headers.common['X-Requested-With'];

        $stateProvider

            .state('app', {
                url: "/app",
                abstract: true,
                templateUrl: "templates/menu.html",
                controller: 'AppCtrl'
            })

            .state('app.home', {
                url: "/home",
                views: {
                    'menuContent': {
                        templateUrl: "templates/home.html",
                        controller: "HomeController"
                    }
                }
            })

            /***********************************/
            /* TELFORM                         */
            /***********************************/

            .state('app.telform-extra', {
                url: "/telform-extra",
                views: {
                    'menuContent': {
                        templateUrl: "templates/telform-extra.html",
                        controller: "TelformExtraController"
                    }
                }
            })

            .state('app.telform-naw', {
                url: "/telform-naw",
                views: {
                    'menuContent': {
                        templateUrl: "templates/telform-naw.html",
                        controller: "TelformNawController"
                    }
                }
            })

            .state('app.telform-bedankt', {
                url: "/telform-bedankt",
                views: {
                    'menuContent': {
                        templateUrl: "templates/telform-bedankt.html",
                        controller: "TelformBedanktController"
                    }
                }
            })


            /***********************************/
            /* VOGELDAGBOEK                    */
            /***********************************/


            .state('app.vogeldagboek', {
                url: "/vogeldagboek",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogeldagboek.html",
                        controller: "VogelDagboekController"
                    }
                }
            })

            .state('app.vogeldagboek-add', {
                url: "/vogeldagboek/add",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogeldagboek-add.html",
                        controller: "VogelDagboekAddController"
                    }
                }
            })

            .state('app.vogeldagboek-details', {
                url: "/vogeldagboek/details",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogeldagboek-details.html",
                        controller: "VogelDagboekDetailsController"
                    }
                }
            })

            .state('app.vogeldagboek-count', {
                url: "/vogeldagboek/count",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogeldagboek-count.html",
                        controller: "VogelDagboekCountController"
                    }
                }
            })


            /***********************************/
            /* VOGELGIDS                       */
            /***********************************/

            .state('app.vogels', {
                url: "/vogels",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogels.html",
                        controller: 'VogelsController'
                    },
                    'navable-modal@': {
                        templateUrl: 'templates/filter-main.html'
                    }
                }
            })

            .state('app.vogels.sizes', {
                url: '/vogels/modal/sizes',
                views: {
                    '': {
                        templateUrl: 'templates/vogels.html'
                    },
                    'navable-modal@': {
                        templateUrl: 'templates/filter-sizes.html'
                    }
                }
            })


            .state('app.vogels.colors', {
                url: '/vogels/modal/colors',
                views: {
                    '': {
                        templateUrl: 'templates/vogels.html'
                    },
                    'navable-modal@': {
                        templateUrl: 'templates/filter-colors.html'
                    }
                }
            })


            .state('app.vogels.silhouettes', {
                url: '/vogels/modal/silhouettes',
                views: {
                    '': {
                        templateUrl: 'templates/vogels.html'
                    },
                    'navable-modal@': {
                        templateUrl: 'templates/filter-silhouettes.html'
                    }
                }
            })


            .state('app.vogels.beaks', {
                url: '/vogels/modal/beaks',
                views: {
                    '': {
                        templateUrl: 'templates/vogels.html'
                    },
                    'navable-modal@': {
                        templateUrl: 'templates/filter-beaks.html'
                    }
                }
            })


            .state('app.vogels-details', {
                url: "/vogels/:id",
                views: {
                    'menuContent': {
                        templateUrl: "templates/vogels-details.html",
                        controller: 'VogelsDetailsController'
                    }
                }
            })


            /***********************************/
            /* TWEETS                          */
            /***********************************/


            .state('app.tweets', {
                url: "/tweets",
                views: {
                    'menuContent': {
                        templateUrl: "templates/tweets.html",
                        controller: 'SocialController'
                    }
                }
            })


            /***********************************/
            /* FAQ                             */
            /***********************************/


            .state('app.informatie', {
                url: "/informatie",
                views: {
                    'menuContent': {
                        templateUrl: "templates/informatie.html",
                        controller: 'InfoController'
                    }
                }
            })


            .state('app.informatie-details', {
                url: "/informatie/:id",
                views: {
                    'menuContent': {
                        templateUrl: "templates/informatie-details.html",
                        controller: 'InfoDetailsController'
                    }
                }
            })




            /***********************************/
            /* REGISTRATION, PROFILE AND LOGIN */
            /***********************************/

            .state('app.profiel', {
                url: "/profiel",
                views: {
                    'menuContent': {
                        templateUrl: "templates/registratie-form.html",
                        controller: 'ProfielController'
                    }
                }
            })


            .state('app.registratie', {
                url: "/registratie",
                views: {
                    'menuContent': {
                        templateUrl: "templates/registratie.html",
                        controller: 'LoginController'
                    }
                }
            })

            .state('app.registratie-select', {
                url: "/registratie-select",
                views: {
                    'menuContent': {
                        templateUrl: "templates/registratie-select.html"
                    }
                }
            })

            .state('app.registratie-form', {
                url: "/registratie-form",
                views: {
                    'menuContent': {
                        templateUrl: "templates/registratie-form.html",
                        controller: 'ProfielController'
                    }
                }
            })

            .state('app.login', {
                url: "/login",
                views: {
                    'menuContent': {
                        templateUrl: "templates/login.html",
                        controller: 'LoginController'
                    }
                }
            });
        // if none of the above states are matched, use this as the fallback
        $urlRouterProvider.otherwise('/app/home');
    });