angular.module('tuinvogels.controllers-dagboek', [])

    /***************************/
    /* VogelDagboekController  */
    /***************************/
    .controller('VogelDagboekController', function ($scope, $rootScope, $state, $timeout, $cordovaNetwork, $cordovaGoogleAnalytics, TelFactory, StorageFactory, SyncFactory, $cordovaDialogs, $cordovaNetwork, $ionicListDelegate) {

        try {
            $cordovaGoogleAnalytics.trackView('Tellingen');
        } catch (e) { };

        var i, j, uuidToRemove, idToRemove
        dagboek = StorageFactory.getObject('dagboek');
        tellijsten = dagboek.tellijsten || [],
            dellijsten = dagboek.dellijsten || [];

        var sortDagboek = function (keyedList) {

            var groupedList = _.groupBy(keyedList, 'season');
            var keys = Object.keys(groupedList).sort().reverse();
            var sortedList = [];

            for (var i = 0; i < keys.length; i++) {
                sortedList.push(groupedList[keys[i]]);
            }
            return sortedList;
        }

        $scope.search = {};
        $scope.canSwipe = true;
        $scope.dagboek = sortDagboek(tellijsten);


        try {
            $scope.canSync = $rootScope.credentials.uuid != '' && $cordovaNetwork.isOnline();

            if ($scope.canSync) {
                $scope.showSyncIndicator = true;
                $timeout(function () {
                    $scope.showSyncIndicator = false;
                }, 4000)
            }

            else $scope.showSyncIndicator = false;
        } catch (e) {
            $scope.canSync = true;

            if ($scope.canSync) {
                $scope.showSyncIndicator = true;
                $timeout(function () {
                    $scope.showSyncIndicator = false;
                }, 4000)
            }

            else $scope.showSyncIndicator = false;
        }


        $scope.next = function () {
            $state.go('app.vogeldagboek-add');
        }

        $scope.sync = function () {
            var pending = _.filter(tellijsten, { 'id': null });
            var synced = _.map(_.filter(tellijsten, function (t) { return t.id != null }), 'id');
            var deleted = dellijsten;


            SyncFactory.sync({ pending: pending, synced: synced, deleted: deleted }, $rootScope.credentials.uuid).then(function (res) {

                try {
                    if (res.iddata.length) {
                        for (i = 0; i < res.iddata.length; i++) {
                            for (j = 0; j < tellijsten.length; j++) {
                                if (tellijsten[j].uuid == res.iddata[i].uuid) {
                                    tellijsten[j].id = res.iddata[i].id;
                                    break;
                                }
                            }
                        }
                    }
                } catch (e) { }

                try {
                    if (res.entrydata.length) {
                        for (i = 0; i < res.entrydata.length; i++) {
                            tellijsten.push(res.entrydata[i]);
                        }
                    }
                } catch (e) { }

                try {
                    if (res.deletedata.length) {
                        for (i = 0; i < res.deletedata.length; i++) {

                            for (j = 0; j < tellijsten.length; j++) {
                                if (tellijsten[j].id == parseInt(res.deletedata[i])) {
                                    tellijsten.splice(j, 1);
                                    break;
                                }
                            }

                        }
                    }
                } catch (e) { }


                $scope.dagboek = sortDagboek(tellijsten);
                StorageFactory.setObject('dagboek', { 'tellijsten': tellijsten, 'dellijsten': [] });
                dellijsten = [];
                $scope.$broadcast('scroll.refreshComplete');
            }, function () {
                alert('failure');
                $scope.$broadcast('scroll.refreshComplete');
            });
        }


        $scope.clearSearch = function () {
            $scope.search.$ = "";
        };


        $scope.showTellijst = function (tellijst) {
            TelFactory.setActiveLijst(tellijst);
            $state.go('app.vogeldagboek-count');
        };


        var onConfirmDelete = function (buttonIndex) {

            $ionicListDelegate.closeOptionButtons();
            if (buttonIndex == 2) {
                deleteTellijst();
            }
        };

        $scope.delete = function (uuid, id) {
            uuidToRemove = uuid;
            idToRemove = id;

            try {
                $cordovaDialogs.confirm("Weet u zeker dat u deze telling wilt verwijderen uit uw lijst met tellingen?", "Tellijst verwijderen", ['Ja', 'Annuleer'])
                    .then(function (index) {
                        $ionicListDelegate.closeOptionButtons();
                        if (index == 1) {
                            deleteTellijst();
                        }
                    });
            } catch (e) { }
        };

        var deleteTellijst = function () {
            _.remove(tellijsten, function (lijst) {
                return lijst.uuid == uuidToRemove;
            });

            if (idToRemove != null) {
                dellijsten.push(idToRemove);
            }
            StorageFactory.setObject('dagboek', { 'tellijsten': tellijsten, 'dellijsten': dellijsten });
            $scope.dagboek = sortDagboek(tellijsten);
            //$scope.$apply();
        };
    })

    /******************************/
    /* VogelDagboekAddController  */
    /******************************/
    .controller('VogelDagboekAddController', function ($scope, $state, $stateParams, $cordovaDialogs, $ionicScrollDelegate, SettingsFactory, TelFactory, DataService) {

        $scope.birds = _.filter(DataService.birds, { top25: 1 });
        $scope.otherbirds = _.filter(DataService.birds, { top25: 0, active: 1 });
        $scope.isWeekend = (SettingsFactory.isWeekend());

        //Added unrecognized bird option
        $scope.birds.push({
            id: 97,
            bird: 'Niet-herkende vogels',
            count: 0,
            reference: 'onbekend',
            threshold: 99
        })

        $scope.selection = {
            other: null
        };

        $scope.nultelling = function () {
            if (!emptyTellijst()) {
                $cordovaDialogs.alert('U heeft al aangegeven vogels te hebben geteld.', 'Geen vogels geteld?', 'Sluiten').then(function () {
                });
            } else {
                $scope.next();
            }
        }

        $scope.next = function () {
            if (emptyTellijst()) {
                $cordovaDialogs.confirm('Weet u zeker dat u een 0-telling wilt opslaan?', 'Geen telgegevens', ['Ja', 'Annuleer']).then(function (index) {
                    if (index === 1) {
                        TelFactory.updateTellingBirds($scope.birds);
                        $state.go('app.vogeldagboek-details');
                    }
                });
            } else {
                TelFactory.updateTellingBirds($scope.birds);
                $state.go('app.vogeldagboek-details');
            }
        }

        $scope.addToList = function (newbird, position) {

            if (newbird || $scope.selection.other) {

                position = position || 'bottom';

                newbird = newbird || $scope.selection.other;

                newbird.count = newbird.count || 1;
                if (position == 'bottom') $scope.birds.push(newbird);
                else $scope.birds.unshift(newbird);
                var removed = _.remove($scope.otherbirds, function (bird) {
                    return bird.id === newbird.id
                });
                $ionicScrollDelegate.scrollBottom();
            }
        }

        // set counted previously values
        TelFactory.initBirdList($scope.birds);

        var telling = TelFactory.getTelling();

        // add previously counted birds not in top-25
        _.forEach(telling.birds, function (bird) {
            if (!_.find($scope.birds, { 'bird': bird.bird })) {
                $scope.addToList(bird, 'top');
            }
        })
        $ionicScrollDelegate.scrollTop();



        var emptyTellijst = function () {
            for (var i = 0; i < $scope.birds.length; i++) {
                if ($scope.birds[i].count > 0) return false;
            }
            return true
        };

    })


    /**********************************/
    /* VogelDagboekDetailsController  */
    /**********************************/
    .controller('VogelDagboekDetailsController', function ($scope, $state, $ionicSlideBoxDelegate, TelFactory, StorageFactory, SettingsFactory) {

        $scope.telling = TelFactory.getTelling();
        $scope.telling.weekend = false;
        if (SettingsFactory.isWeekend()) $scope.telling.weekend = true;

        $scope.showWeekend = $scope.telling.weekend;

        $scope.randomIndexForImage = Math.floor(Math.random() * $scope.telling.birds.length);

        var S4 = function () {
            return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
        }

        var getSeason = function (date) {
            var seasons = ['4', '4', '1', '1', '1', '2', '2', '2', '3', '3', '3', '4'];
            return seasons[date.getMonth()];
        }


        // setting mobi scroller
        $scope.defaultDate = new Date();
        $scope.endYear = $scope.defaultDate.getFullYear();
        $scope.startYear = $scope.endYear - 1;
        $scope.stepMinute = 5;
        $scope.monthNames = ['Januari', 'Februari', 'Maart', 'April', 'Mei', 'Juni', 'Juli', 'Augustus', 'September', 'Oktober', 'November', 'December'];

        $scope.onBeforeShowHandler = function () {
            if ($scope.telling.date !== undefined) {
                $('#date').mobiscroll('setDate', $scope.telling.date)
            }
        };
        $scope.onSelectHandler = function (valText, inst) {
            $scope.$apply(function () {
                $scope.telling.date = inst.getDate();
            });
        };


        $scope.save = function () {

            //set random image for tellijst
            if ($scope.telling.birds.length) {
                $scope.telling['preferredimage'] = $scope.telling.birds[$scope.randomIndexForImage].reference;
                $scope.telling['preferredimageid'] = $scope.telling.birds[$scope.randomIndexForImage].id;
            }
            else {
                $scope.telling['preferredimage'] = 'nul-telling';
                $scope.telling['preferredimageid'] = null;
            }
            //set uuid
            $scope.telling['uuid'] = (S4() + S4() + "-" + S4() + "-4" + S4().substr(0, 3) + "-" + S4() + "-" + S4() + S4() + S4()).toLowerCase();
            //add season
            $scope.telling['season'] = $scope.telling.date.getFullYear() + '-' + getSeason($scope.telling.date);

            var currentList = StorageFactory.getObject('dagboek').tellijsten || [];
            currentList.push($scope.telling);

            StorageFactory.setObject('dagboek', { 'tellijsten': currentList });


            if (!$scope.telling.weekend) {
                //clear current telling
                TelFactory.resetTelling();
                $state.go('app.vogeldagboek');
            }
            else {
                TelFactory.setTelling($scope.telling);
                $state.go('app.telform-extra');
            }
        };
    })


    /********************************/
    /* VogelDagboekCountController  */
    /********************************/
    .controller('VogelDagboekCountController', function ($scope, $stateParams, TelFactory, DataService, StorageFactory, SettingsFactory) {

        $scope.telling = TelFactory.getActiveLijst();
        $scope.birds = DataService.birds;

    });