angular.module('tuinvogels.controllers-telform', [])

	/***************************/
	/* TelformController       */
	/***************************/
	.controller('TelformExtraController', function ($scope, $state, TelFactory) {

		$scope.telling = TelFactory.getTelling();
		$scope.maxtellers = 25;

		$scope.getNumber = function (num) {
			return new Array(num);
		}

		$scope.save = function () {
			TelFactory.setTelling($scope.telling);
			$state.go('app.telform-naw');
		}

	})

	.controller('TelformNawController', function ($scope, $state, $ionicPopup, TelFactory, AuthorizationFactory, RegistrationFactory, WeekendFactory) {

		$scope.telling = TelFactory.getTelling();

		//default values
		$scope.telling['tussenvoegsel'] = '';
		$scope.telling['toevoeging'] = '';
		$scope.telling['bezwaar'] = false;
		$scope.telling['nieuwsbrief'] = false;
		$scope.telling['intratuinactie'] = false;


		var credentials = AuthorizationFactory.getCredentials();
		var registered = (credentials.uuid && credentials.uuid != '');

		if (registered) {
			RegistrationFactory.get(credentials.uuid).then(function (res) {
				if (res.status != false) {

					for (var k in res) $scope.telling[k] = res[k];
					$scope.telling['uuid'] = credentials.uuid;
					$scope.telling['huisnummer'] = parseInt(res.huisnummer);
					$scope.telling['bezwaar'] = (res.bezwaar > 0);
				}
			})
		}

		$scope.save = function () {
			TelFactory.setTelling($scope.telling);

			WeekendFactory.save($scope.telling).then(function (res) {

				if (res.status != false) {
					WeekendFactory.setUUID(res.uuid);
					TelFactory.resetTelling();
					$state.go('app.telform-bedankt');
				}
				else {
					$ionicPopup.alert({
						title: 'Waarschuwing',
						template: 'Er is een fout opgetreden. Probeer het (later) nog eens.'
					});
				}
			})

		}

	})

	.controller('TelformBedanktController', function ($scope, $rootScope, bitly, WeekendFactory) {

		var uuid = WeekendFactory.getUUID();
		var longUrl = $rootScope.SETTINGS.baseUrl + 'resultaten/mijn-telling/?uuid=' + uuid;

		bitly.getShortUrl(longUrl).then(function (data) {
			$scope.bitlyUrl = data;
		}, function (e) {
			$scope.bitlyUrl = e;
		});
	});