angular.module('tuinvogels.directives', [])


.directive('external', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $attr.target = $attr.target || '_blank';

            $element.bind('click', function(e) {
                e.preventDefault();
                window.open($attr.href, $attr.target);
            });
        }
    };
})

.directive('resettingImg', function() {
    return {
        restrict: 'A',
        link: function(scope, element, attr) {

            var currentElement = element;
            attr.$observe('src', function(src) {
                var newImg = element.clone(true);
                newImg.attr('src', src);
                currentElement.replaceWith(newImg);
                currentElement = newImg;
            });

        }
    };
})


.directive('preference', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $element.bind('click', function(e) {

                var index = $(this).data('index');

                $(this).siblings().removeClass('preferred');
                $(this).addClass('preferred');
                $scope.$parent.$parent.$parent.randomIndexForImage = index;
            });
        }
    };
})


.directive('scroll', function($ionicGesture, $ionicScrollDelegate) {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $ionicGesture.on('swipeleft', function(e) {
                $ionicScrollDelegate.scrollBy(160, 0, true);
            }, $element);


            $ionicGesture.on('swiperight', function(e) {
                $ionicScrollDelegate.scrollBy(-160, 0, true);
            }, $element);
        }
    };
})


.directive('facebook', function($state, $window) {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            var loginWindow, startTime;

            function loginWindow_loadStartHandler(event) {
                var url = event.url;
                if (url.indexOf("registratie.registratie")) {
                    var timeout = 600 - (new Date().getTime() - startTime);
                    setTimeout(function() {
                        loginWindow.close();
                    }, timeout > 0 ? timeout : 0);
                    $state.go('app.vogelvinder');
                }
            }

            function loginWindow_exitHandler() {
                loginWindow.removeEventListener('loadstop', loginWindow_loadStartHandler);
                loginWindow.removeEventListener('exit', loginWindow_exitHandler);
                loginWindow = null;
            }

            $attr.target = $attr.target || '_blank';

            $element.bind('click', function(e) {
                e.preventDefault();

                startTime = new Date().getTime();
                loginWindow = $window.open($attr.href, $attr.target, 'toolbar=0');

                loginWindow.addEventListener('loadstart', loginWindow_loadStartHandler);
                loginWindow.addEventListener('exit', loginWindow_exitHandler);
            });
        }
    };
})


.directive('datePicker', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {
            $element.bind('click', function(e) {
                e.preventDefault();
                $('#date-picker').mobiscroll('show');
                return false;
            });
        }
    };
})

.directive('counter', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $element.bind('blur', function(e) {
                e.preventDefault();

                if ($element.val() < 0) $scope.bird = 0;
                if ($element.val() > 999) $scope.bird = 999;
                if ($scope.bird.count > $scope.bird.threshhold) $scope.bird.warning = true;
                else $scope.bird.warning = false;
                $scope.$digest();
            });
        }
    };
})

.directive('increment', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $element.bind('click', function(e) {
                e.preventDefault();

                $scope.bird.count++;
                if ($scope.bird.count > $scope.bird.threshhold) $scope.bird.warning = true;
                $scope.$digest();
            });
        }
    };
})

.directive('decrement', function() {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $element.bind('click', function(e) {
                e.preventDefault();

                if ($scope.bird.count > 0) $scope.bird.count--;
                if ($scope.bird.count <= $scope.bird.threshhold) $scope.bird.warning = false;
                $scope.$digest();
            });
        }
    };
})

.directive('share', function($cordovaSocialSharing) {
    return {
        restrict: 'A',
        link: function($scope, $element, $attr) {

            $element.bind('click', function(e) {
                e.preventDefault();

                if ($attr.social == 'Facebook') {
                    $cordovaSocialSharing.shareViaFacebook($attr.message, $attr.image, null).then(function(result) {
                        // Success! 
                    },
                    function(err) {
                        // An error occured. Show a message to the user
                        console.log('error', err);
                    });
                }
                else {
                    $cordovaSocialSharing.shareViaTwitter($attr.message, $attr.image, null).then(function(result) {
                        // Success! 
                    },
                    function(err) {
                        // An error occured. Show a message to the user
                    });
                }
            });
        }
    };
});
