angular.module('tuinvogels.filters', [])

.filter('capitalize', function() {
    return function(string) {
        return string.charAt(0).toUpperCase() + string.slice(1);
    };
})

.filter('seasonalize', function() {
    return function(string) {
        var seasons = ['Lente', 'Zomer', 'Herfst', 'Winter'];
        var year = string.split('-')[0];
        var season = parseInt(string.split('-')[1]);
        return seasons[season - 1] + ' ' + year;
    };
})

.filter('orderObjectBy', function() {
    return function(items, field, reverse) {
        var filtered = [];
        angular.forEach(items, function(item) {
            filtered.push(item);
        });
        filtered.sort(function(a, b) {
            return (a[field] > b[field] ? 1 : -1);
        });
        if (reverse) filtered.reverse();
        return filtered;
    };
})

.filter('reverse', function() {
    return function(items) {
        return items.slice().reverse();
    };
});
