
angular.module('services.push', [])

/*****************************************************************************/
/* PushService ***************************************************************/
/*****************************************************************************/
.service('PushService', function($rootScope, $cordovaPush, $cordovaDialogs, $cordovaVibration, RemoteFactory, StorageFactory) {

    var deviceId,
        devicePlatform;

    var storeNotificationId = function(id, platform) {
        deviceId = id;
        devicePlatform = platform;
        RemoteFactory.get('push.storeId&id=' + id + '&platform=' + platform);
    }

    return {
        register: function(platform) {

            var push = PushNotification.init({
                android : {
                    senderID: "267974563795",
                    sound: true,
                    vibrate: true,
                    clearNotifications: true,
                    forceShow: true
                }, 
                ios : {
                    alert: true,
                    badge: true,
                    sound: true,
                    clearBadge: true
                }
            });

            push.on('registration', function(data) {
                storeNotificationId(data.registrationId, platform);

            });

            push.on('notification', function(data) {

                if (data.additionalData && data.additionalData.foreground) {
                    //$rootScope.$broadcast("push:received");
                    $cordovaDialogs.alert(data.message, 'Tuinvogels, Vogelbescherming');
                    $cordovaVibration.vibrate(500);
                }
            });

            push.on('error', function(e) {
                //console.log(e.message);
            });
        },
        
        getDeviceId: function() {
            return deviceId;
        },

        setDeviceId: function(id) {
            deviceId = id;
        }
    }
});