angular.module('social', [])

    .factory('Social', function ($rootScope, $q, $window, $http, $timeout) {

        var deferredLogin,
            runningInCordova,
            loginProcessed,
            tokenStore = $window.sessionStorage;


        document.addEventListener("deviceready", function () {
            runningInCordova = true;
        }, false);


        function login(loginUrl) {

            var loginWindow,
                startTime;

            deferredLogin = $q.defer();
            loginProcessed = false;
            logout();


            startTime = new Date().getTime();
            loginWindow = window.open(loginUrl, '_blank', 'location=no');

            // If the app is running in Cordova, listen to URL changes in the InAppBrowser until we get a URL with an access_token or an error
            if (runningInCordova) {
                loginWindow.addEventListener('loadstart', function (event) {

                    var url = event.url;
                    
                    if (url.indexOf("registratie.appfinish") > -1) {

                        var timeout = 600 - (new Date().getTime() - startTime);
                        
                        $timeout(function() {
                            loginWindow.close();
                        }, timeout);
                        
                        oauthCallback(url);
                    }
                });

                loginWindow.addEventListener('exit', function () {
                    deferredLogin.reject({status: 100, error: 'user_cancelled', error_description: 'User cancelled login process', error_reason: "user_cancelled"});
                });
            }

            return deferredLogin.promise;

        }


        function oauthCallback(url) {

            var status,
                queryString,
                obj;

            loginProcessed = true;
            queryString = url.substr(url.indexOf('?') + 1);
            obj = parseQueryString(queryString);
            
            var status = parseInt(obj['status']);

            if (status == 200) {
                deferredLogin.resolve({uuid: obj['code'].split('#')[0]});
            } else {
                deferredLogin.reject();
            }
        }


        function logout() {
            tokenStore['fbtoken'] = undefined;
        }


        function parseQueryString(queryString) {
            var qs = decodeURIComponent(queryString),
                obj = {},
                params = qs.split('&');
            params.forEach(function (param) {
                var splitter = param.split('=');
                obj[splitter[0]] = splitter[1];
            });
            return obj;
        }

        return {
            login: login,
            logout: logout,
            oauthCallback: oauthCallback
        }

    });


// Global function called back by the OAuth login dialog
function oauthCallback(url) {
    var injector = angular.element(document.getElementById('main')).injector();
    injector.invoke(function (Social) {
        Social.oauthCallback(url);
    });
}
